## multipath-tools 0.4.1

=== path_priority/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
BUILD = glibc
DEBUG = 0

include ../Makefile.inc

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS} -I$(libdmdir) \
		 -I$(multipathdir) -DDEBUG=$(DEBUG)
	OBJS = pp_balance_units.o $(DMLIB)-$(BUILD).a \
	       $(MULTIPATHLIB)-$(BUILD).a
else
	CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes \
		 -I$(multipathdir) -DDEBUG=$(DEBUG)
	LDFLAGS = -ldevmapper
	OBJS = pp_balance_units.o $(MULTIPATHLIB)-$(BUILD).a
endif

EXEC = pp_balance_units

all: $(BUILD)

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) -o $(EXEC) $(OBJS) $(LDFLAGS)
#	$(STRIP) $(EXEC)
	
klibc: prepare $(KLIBC) $(OBJS)
	$(LD) -o $(EXEC) $(CRT0) $(OBJS) $(KLIBC) $(LIBGCC)
	$(STRIP) $(EXEC)

$(DMLIB)-$(BUILD).a:
	make -C $(libdmdir) BUILD=$(BUILD) $(BUILD)

$(MULTIPATHLIB)-$(BUILD).a:
	make -C $(multipathdir) BUILD=$(BUILD) $(BUILD)

$(KLIBC):
	rm -f $(klibcdir)/linux
	ln -s $(KERNEL_BUILD) $(klibcdir)/linux
	make -C $(klibcdir)

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)

clean:
	rm -f core *.o $(EXEC) *.gz

## multipath-tools 0.4.2.4

=== dmadm/Makefile ===
BUILD = glibc

EXEC = dmadm

include ../Makefile.inc

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS =  ${REQFLAGS} ${OPTFLAGS} -I$(sysfsdir) -I$(libdmdir)
	OBJS = util.o dmadm.o $(SYSFSLIB)-$(BUILD).a $(DMLIB)-$(BUILD).a
else
	CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes
	LDFLAGS = -ldevmapper -lsysfs
	OBJS = util.o dmadm.o
endif

all: $(BUILD)

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(STRIP) $(EXEC)

klibc: prepare $(KLIBC) $(OBJS)
	$(LD) -o $(EXEC) $(CRT0) $(OBJS) $(KLIBC) $(LIBGCC)
	$(STRIP) $(EXEC)

$(SYSFSLIB)-$(BUILD).a:
	make -C $(sysfsdir) BUILD=$(BUILD) $(BUILD)

$(DMLIB)-$(BUILD).a:
	make -C $(libdmdir) BUILD=$(BUILD) $(BUILD)

$(KLIBC):
	rm -f $(klibcdir)/linux
	ln -s $(KERNEL_BUILD) $(klibcdir)/linux
	make -C $(klibcdir)

clean:
	rm -f $(OBJS) *.o $(EXEC) *~

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)

$(OBJS): mdadm.h

=== kpartx/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD=glibc

include ../Makefile.inc

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS} -I$(libdmdir) -I. -I$(multipathdir)
	OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o gpt.o crc32.o \
	       lopart.o xstrncpy.o \
	       $(MULTIPATHLIB)-$(BUILD).a $(DMLIB)-$(BUILD).a
else
	CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes -I. \
		 -I$(multipathdir)
	LDFLAGS = -ldevmapper
	OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o \
	       gpt.o crc32.o lopart.o xstrncpy.o $(MULTIPATHLIB)-$(BUILD).a
endif

EXEC = kpartx

all: $(BUILD)

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(STRIP) $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	
klibc: prepare $(KLIBC) $(OBJS)
	$(LD) -o $(EXEC) $(CRT0) $(OBJS) $(KLIBC) $(LIBGCC)
	$(STRIP) $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

$(DMLIB)-$(BUILD).a:
	make -C $(libdmdir) BUILD=$(BUILD)

$(MULTIPATHLIB)-$(BUILD).a:
	make -C $(multipathdir) BUILD=$(BUILD)

$(KLIBC):
	rm -f $(klibcdir)/linux
	ln -s $(KERNEL_BUILD) $(klibcdir)/linux
	make -C $(klibcdir)

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXEC)
	rm -f $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== libcheckers/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD = glibc

include ../Makefile.inc

OBJS = readsector0.o tur.o selector.o checkers.o emc_clariion.o

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS}
else
	CFLAGS =
endif

all: $(BUILD)

prepare:
	rm -f core *.o *.gz

klibc: prepare $(KLIBC) $(OBJS)
	ar rs libcheckers-klibc.a *.o

glibc: prepare $(OBJS)
	ar rs libcheckers-glibc.a *.o

$(KLIBC):
	rm -f $(klibcdir)/linux
	ln -s $(KERNEL_BUILD) $(klibcdir)/linux
	make -C $(klibcdir)

install:

uninstall:

clean:
	rm -f core *.a *.o *.gz

=== libmultipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD = glibc

include ../Makefile.inc

OBJS = memory.o parser.o vector.o devmapper.o callout.o \
       sysfs_devinfo.o hwtable.o blacklist.o util.o

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS} -I$(libdmdir)
else
	CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes
endif

all: $(BUILD)

prepare:
	rm -f core *.o *.gz

klibc: prepare $(KLIBC) $(OBJS)
	ar rs libmultipath-klibc.a *.o

glibc: prepare $(OBJS)
	ar rs libmultipath-glibc.a *.o

$(KLIBC):
	rm -f $(klibcdir)/linux
	ln -s $(KERNEL_BUILD) $(klibcdir)/linux
	make -C $(klibcdir)

install:

uninstall:

clean:
	rm -f core *.a *.o *.gz

=== multipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
BUILD = glibc

include ../Makefile.inc

OBJS = pgpolicies.o propsel.o devinfo.o main.o dict.o dmparser.o \
       $(MULTIPATHLIB)-$(BUILD).a $(CHECKERSLIB)-$(BUILD).a

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS} -DDEBUG=${DEBUG} \
		 -DVERSION=$(VERSION) -I$(multipathdir) \
		 -I$(libdmdir) -I$(sysfsdir) -I$(checkersdir)
	OBJS += $(SYSFSLIB)-$(BUILD).a $(DMLIB)-$(BUILD).a
else
	CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes \
		 -DDEBUG=$(DEBUG) -I$(multipathdir) -I$(checkersdir) \
		 -DVERSION=$(VERSION)
	LDFLAGS = -ldevmapper -lsysfs
endif

EXEC = multipath
DEBUG = 0

all: $(BUILD)

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(STRIP) $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	
klibc: prepare $(KLIBC) $(OBJS)
	$(LD) -o $(EXEC) $(CRT0) $(OBJS) $(KLIBC) $(LIBGCC)
	$(STRIP) $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

$(CHECKERSLIB)-$(BUILD).a:
	make -C $(checkersdir) BUILD=$(BUILD) $(BUILD)

$(MULTIPATHLIB)-$(BUILD).a:
	make -C $(multipathdir) BUILD=$(BUILD) $(BUILD)

$(SYSFSLIB)-$(BUILD).a:
	make -C $(sysfsdir) BUILD=$(BUILD) $(BUILD)

$(DMLIB)-$(BUILD).a:
	make -C $(libdmdir) BUILD=$(BUILD) $(BUILD)

$(KLIBC):
	rm -f $(klibcdir)/linux
	ln -s $(KERNEL_BUILD) $(klibcdir)/linux
	make -C $(klibcdir)

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	install -d $(DESTDIR)/etc/dev.d/block/
	install -m 755 multipath.dev $(DESTDIR)/etc/dev.d/block/
	install -d $(DESTDIR)/etc/udev/rules.d
	install -m 755 multipath.rules $(DESTDIR)/etc/udev/rules.d/
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm $(DESTDIR)/etc/dev.d/block/multipath.dev
	rm $(DESTDIR)/etc/udev/rules.d/multipath.rules
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== multipathd/Makefile ===
BUILD = glibc
EXEC = multipathd

#
# debug verbosity, same as syslog.h
# nothing to below 5, full debug at 7
#
LOGLEVEL = 7

include ../Makefile.inc

#
# directories where to put stuff
#
bindir = /usr/bin
mandir = /usr/share/man/man8
rcdir = /etc/init.d

#
# basic flags setting
#
CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes -DLOGLEVEL=$(LOGLEVEL) \
	 -I$(multipathdir) -I$(checkersdir)
LDFLAGS = -lpthread -ldevmapper -lsysfs

#
# object files
#
OBJS = main.o copy.o devinfo.o dict.o \
       $(CHECKERSLIB)-glibc.a \
       $(MULTIPATHLIB)-glibc.a \

#
# directives
#
all : $(BUILD)

glibc: $(EXEC)

klibc: glibc

$(EXEC): $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	strip $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

$(CHECKERSLIB)-glibc.a:
	$(MAKE) -C $(checkersdir) BUILD=glibc glibc

$(MULTIPATHLIB)-glibc.a:
	$(MAKE) -C $(multipathdir) BUILD=glibc glibc

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)
	install -d $(DESTDIR)$(rcdir)
	install -m 755 multipathd.init $(DESTDIR)$(rcdir)/$(EXEC)
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXEC)
	rm -f $(DESTDIR)$(rcdir)/$(EXEC)
	rm -f $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== klibc-0.190/klibc/Makefile ===
#
# Makefile
#
# Main makefile
#

# Include configuration rules
include MCONFIG

TESTS   = $(patsubst %.c,%,$(wildcard tests/*.c)) \
	  $(patsubst %.c,%.shared,$(wildcard tests/*.c))
LIBOBJS = vsnprintf.o snprintf.o vsprintf.o sprintf.o \
	  asprintf.o vasprintf.o \
	  vsscanf.o sscanf.o ctypes.o \
	  strntoumax.o strntoimax.o \
	  atoi.o atol.o atoll.o \
	  strtol.o strtoll.o strtoul.o strtoull.o \
	  strtoimax.o strtoumax.o \
	  globals.o exitc.o atexit.o onexit.o \
	  execl.o execle.o execv.o execvpe.o execvp.o execlp.o execlpe.o \
	  fork.o wait.o wait3.o waitpid.o system.o setpgrp.o getpgrp.o \
	  daemon.o \
	  printf.o vprintf.o fprintf.o vfprintf.o perror.o \
	  statfs.o fstatfs.o umount.o \
	  open.o fopen.o fread.o fread2.o fgetc.o fgets.o \
	  fwrite.o fwrite2.o fputc.o fputs.o puts.o putchar.o \
	  sleep.o usleep.o strtotimespec.o strtotimeval.o \
	  raise.o abort.o assert.o alarm.o pause.o \
	  __signal.o sysv_signal.o bsd_signal.o siglist.o siglongjmp.o \
	  sigaction.o sigpending.o sigprocmask.o sigsuspend.o \
	  brk.o sbrk.o malloc.o realloc.o calloc.o mmap.o \
	  memcpy.o memcmp.o memset.o memccpy.o memmem.o memswap.o \
	  memmove.o memchr.o \
	  strcasecmp.o strncasecmp.o strndup.o strerror.o \
	  strcat.o strchr.o strcmp.o strcpy.o strdup.o strlen.o strnlen.o \
	  strncat.o strlcpy.o strlcat.o \
	  strstr.o strncmp.o strncpy.o strrchr.o strspn.o \
	  strsep.o strtok.o \
	  gethostname.o getdomainname.o getcwd.o \
	  seteuid.o setegid.o \
	  getenv.o setenv.o putenv.o __put_env.o unsetenv.o \
	  getopt.o readdir.o \
	  syslog.o closelog.o pty.o getpt.o isatty.o reboot.o \
	  time.o utime.o llseek.o nice.o getpriority.o \
	  qsort.o \
	  lrand48.o jrand48.o mrand48.o nrand48.o srand48.o seed48.o \
	  inet/inet_ntoa.o inet/inet_aton.o inet/inet_addr.o \
	  inet/inet_ntop.o inet/inet_pton.o inet/bindresvport.o \
	  send.o recv.o
ifeq ($(ERRLIST),1)
LIBOBJS += errlist.o
endif

SOLIB   = libc.so
SOHASH  = klibc.so

CRT0    = crt0.o
LIB     = libc.a

INTERP_O = interp.o

all: tests $(CRT0) $(LIB) $(SOLIB) klibc.so

# Add any architecture-specific rules
include arch/$(ARCH)/Makefile.inc
EMAIN ?= -e main

tests: $(TESTS)

tests/%.o : tests/%.c
	$(CC) $(CFLAGS) -c -o $@ $<

# This particular file uses a bunch of formats gcc don't know of, in order
# to test the full range of our vsnprintf() function.  This outputs a bunch
# of useless warnings unless we tell it not to.
tests/testvsnp.o : tests/testvsnp.c
	$(CC) $(CFLAGS) -Wno-format -c -o $@ $<

tests/% : tests/%.o $(LIB) $(CRT0)
	$(LD) $(LDFLAGS) -o $@ $(CRT0) $< $(LIB) $(LIBGCC)
	cp $@ $@.stripped
	$(STRIP) $@.stripped

tests/%.shared : tests/%.o interp.o $(SOLIB)
	$(LD) $(LDFLAGS) -o $@ $(EMAIN) interp.o tests/$*.o -R $(SOLIB) $(LIBGCC)
	cp $@ $@.stripped
	$(STRIP) $@.stripped

$(LIB): __static_init.o $(LIBOBJS) $(ARCHOBJS) syscalls/static.obj socketcalls/static.obj
	rm -f $(LIB)
	$(AR) cq $(LIB) __static_init.o $(LIBOBJS) $(ARCHOBJS) \
		$(wildcard syscalls/*.o) $(wildcard socketcalls/*.o)
	$(RANLIB) $(LIB)

$(SOLIB): $(CRT0) __shared_init.o $(LIBOBJS) $(ARCHOBJS) syscalls/static.obj socketcalls/static.obj
	$(LD) $(LDFLAGS) $(SHAREDFLAGS) -o $@ \
		$(CRT0) __shared_init.o $(LIBOBJS) $(ARCHOBJS) \
	        $(wildcard syscalls/*.o) $(wildcard socketcalls/*.o) \
		$(LIBGCC)

sha1hash: sha1hash.c
	$(HOST_CC) $(HOST_CFLAGS) $(HOST_LDFLAGS) -o $@ $<

$(SOLIB).hash: $(SOLIB) sha1hash
	$(NM) $(SOLIB) | \
		egrep '^[0-9a-fA-F]+ [ADRTW] ' | sort | ./sha1hash > $@

$(SOHASH): $(SOLIB) $(SOLIB).hash
	cp -f $(SOLIB) $@
	$(STRIP) $@
	rm -f klibc-??????????????????????.so
	ln -f $@ klibc-`cat $(SOLIB).hash`.so

$(INTERP_O): interp.S $(SOLIB).hash
	$(CC) $(CFLAGS) -D__ASSEMBLY__ -DLIBDIR=\"$(SHLIBDIR)\" \
		-DSOHASH=\"`cat $(SOLIB).hash`\" \
		-c -o $@ $<

crt0.o: arch/$(ARCH)/crt0.o
	cp arch/$(ARCH)/crt0.o .

errlist.c:
	$(PERL) makeerrlist.pl $(INCLUDE) -errlist > $@ || rm -f $@

# We pass -ansi to keep cpp from define e.g. "i386" as well as "__i386__"
SYSCALLS.i: SYSCALLS.def
	$(CC) $(CFLAGS) -D__ASSEMBLY__ -ansi -x assembler-with-cpp -E -o $@ $<

syscalls.nrs: ../include/sys/syscall.h
	$(CC) $(CFLAGS) -Wp,-dM -x c -E -o $@ $<

syscalls.dir: SYSCALLS.i syscalls.pl arch/$(ARCH)/sysstub.ph syscommon.h syscalls.nrs
	rm -rf syscalls
	mkdir syscalls
	$(PERL) syscalls.pl SYSCALLS.i $(ARCH) $(BITSIZE) syscalls.nrs ../include/klibc/havesyscall.h
	touch $@

../include/klibc/havesyscall.h: syscalls.dir
	: Generated by side effect

socketcalls.dir: SOCKETCALLS.def socketcalls.pl socketcommon.h
	rm -rf socketcalls
	mkdir socketcalls
	$(PERL) socketcalls.pl SOCKETCALLS.def $(ARCH)
	touch $@

%/static.obj: %.dir
	$(MAKE) objects-$(basename $(notdir $@)) DIR=$*/

STATIC = $(addsuffix .o,$(basename $(wildcard $(DIR)*.[cS])))

objects-static: $(STATIC)
	touch $(DIR)static.obj

clean: archclean
	find . -type f -a \( -name \*.[isoa] -o -name \*.l[iso] \) -print0 | xargs -0rt rm -f
	rm -f *.a *.so *.hash *.syms *.stripped
	rm -f $(TESTS) tests/*.stripped
	rm -rf syscalls syscalls.dir
	rm -rf socketcalls socketcalls.dir
	rm -f sha1hash errlist.c

spotless: clean
	rm -f ../include/klibc/havesyscall.h syscalls.nrs
	find . \( -name \*~ -o -name '.*.d' \) -not -type d -print0 | \
		xargs -0rt rm -f

bitsize:
	@echo $(BITSIZE)

ifneq ($(wildcard $(DIR).*.d),)
include $(wildcard $(DIR).*.d)
endif

## multipath-tools 0.4.7

=== Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>

BUILD = glibc

#
# Try to supply the linux kernel headers.
#
ifeq    ($(KRNLSRC),)
KRNLLIB = /lib/modules/$(shell uname -r)
ifeq    ($(shell test -r $(KRNLLIB)/source && echo 1),1)
KRNLSRC = $(KRNLLIB)/source
KRNLOBJ = $(KRNLLIB)/build
else
KRNLSRC = $(KRNLLIB)/build
KRNLOBJ = $(KRNLLIB)/build
endif
endif
export KRNLSRC
export KRNLOBJ

BUILDDIRS = $(shell find . -mindepth 2 -name Makefile -exec dirname {} \; | grep -v ^lib)

VERSION = $(shell basename ${PWD} | cut -d'-' -f3)

all: recurse

recurse:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir BUILD=$(BUILD) VERSION=$(VERSION) \
		KRNLSRC=$(KRNLSRC) KRNLOBJ=$(KRNLOBJ) || exit $?; \
	done

recurse_clean:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir clean || exit $?; \
	done

recurse_install:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir install || exit $?; \
	done

recurse_uninstall:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir uninstall || exit $?; \
	done

clean:	recurse_clean
	rm -f multipath-tools.spec
	rm -rf rpms

install:	recurse_install

uninstall:	recurse_uninstall

release:
	sed -e "s/__VERSION__/${VERSION}/" \
	multipath-tools.spec.in > multipath-tools.spec

rpm: release
	rpmbuild -bb multipath-tools.spec

=== devmap_name/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
BUILD = glibc

include ../Makefile.inc

OBJS = devmap_name.o

ifeq ($(strip $(BUILD)),klibc)
	OBJS += $(libdm)
else
	LDFLAGS = -ldevmapper
endif

EXEC = devmap_name

all: $(BUILD)

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

klibc: prepare $(OBJS)
	$(CC) -static -o $(EXEC) $(OBJS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	install -d $(DESTDIR)$(bindir)
	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== kpartx/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD=glibc

include ../Makefile.inc

CFLAGS += -I. -D_LARGEFILE64_SOURCE

ifeq ($(strip $(BUILD)),klibc)
	OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o gpt.o crc32.o \
	       lopart.o xstrncpy.o devmapper.o dasd.o mac.o \
	       $(MULTIPATHLIB)-$(BUILD).a $(libdm)
else
	LDFLAGS = -ldevmapper
	OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o dasd.o \
	       gpt.o mac.o crc32.o lopart.o xstrncpy.o devmapper.o
endif

EXEC = kpartx

all: $(BUILD)

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	
klibc: prepare $(OBJS)
	$(CC) -static -o $(EXEC) $(CRT0) $(OBJS) $(KLIBC) $(LIBGCC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

$(MULTIPATHLIB)-$(BUILD).a:
	make -C $(multipathdir) BUILD=$(BUILD)

install:
	install -d $(DESTDIR)$(bindir)
	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXEC)
	rm -f $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== libcheckers/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD = glibc

include ../Makefile.inc

OBJS = checkers.o readsector0.o tur.o directio.o emc_clariion.o hp_sw.o

all: $(BUILD)

prepare:
	@file *-$(BUILD).a >/dev/null 2>&1 || rm -f core *.o *.gz

klibc: prepare $(OBJS)
	ar rs libcheckers-klibc.a *.o

glibc: prepare $(OBJS)
	ar rs libcheckers-glibc.a *.o

install:

uninstall:

clean:
	rm -f core *.a *.o *.gz

=== libmultipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD = glibc

include ../Makefile.inc

CFLAGS = -I$(checkersdir)

OBJS = memory.o parser.o vector.o devmapper.o callout.o \
       hwtable.o blacklist.o util.o dmparser.o config.o \
       structs.o discovery.o propsel.o dict.o \
       pgpolicies.o debug.o regex.o defaults.o uevent.o \
       switchgroup.o uxsock.o print.o alias.o log_pthread.o \
       log.o configure.o structs_vec.o

PREVBUILD = $(shell nm debug.o 2> /dev/null|grep log_safe)

ifeq ($(strip $(DAEMON)),1)
	CFLAGS += -DDAEMON
	CLEAN = $(shell if [ "x$(PREVBUILD)" = "x" ]; then echo clean; fi)
else
	CLEAN = $(shell if [ ! "x$(PREVBUILD)" = "x" ]; then echo clean; fi)
endif

all: $(BUILD)

prepare: $(CLEAN)
	@file *-$(BUILD).a >/dev/null 2>&1 || rm -f core *.o *.gz
	@rm -f *-$(BUILD).a

klibc: $(OBJS)
	ar rs libmultipath-klibc.a *.o

glibc: $(OBJS)
	ar rs libmultipath-glibc.a *.o

install:

uninstall:

clean:
	rm -f core *.a *.o *.gz

=== multipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
BUILD = glibc

include ../Makefile.inc

OBJS = main.o $(MULTIPATHLIB)-$(BUILD).a $(CHECKERSLIB)-$(BUILD).a

CFLAGS += -I$(multipathdir) -I$(checkersdir)

ifeq ($(strip $(BUILD)),klibc)
	OBJS += $(libdm) $(libsysfs)
else
	LDFLAGS += -ldevmapper -lsysfs
endif

EXEC = multipath

all: $(BUILD)

prepare:
	make -C $(multipathdir) prepare
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

klibc: prepare $(OBJS)
	$(CC) -static -o $(EXEC) $(CRT0) $(OBJS) $(KLIBC) $(LIBGCC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

$(CHECKERSLIB)-$(BUILD).a:
	make -C $(checkersdir) BUILD=$(BUILD) $(BUILD)

$(MULTIPATHLIB)-$(BUILD).a:
	make -C $(multipathdir) BUILD=$(BUILD) $(BUILD)

install:
	install -d $(DESTDIR)$(bindir)
	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	install -d $(DESTDIR)/etc/udev/rules.d
	install -m 644 multipath.rules $(DESTDIR)/etc/udev/rules.d/
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm $(DESTDIR)/etc/udev/rules.d/multipath.rules
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== multipathd/Makefile ===
BUILD = glibc
EXEC = multipathd

include ../Makefile.inc

#
# basic flags setting
#
CFLAGS += -DDAEMON -I$(multipathdir) -I$(checkersdir)
LDFLAGS = -lpthread -ldevmapper -lsysfs -lreadline -lncurses

#
# debuging stuff
#
#CFLAGS += -DLCKDBG
#CFLAGS += -D_DEBUG_
#CFLAGS += -DLOGDBG

#
# object files
#
OBJS = main.o pidfile.o uxlsnr.o uxclnt.o cli.o cli_handlers.o \
       $(MULTIPATHLIB)-glibc.a $(CHECKERSLIB)-glibc.a \


#
# directives
#
all : $(BUILD)

glibc: $(EXEC)

klibc:
	$(MAKE) BUILD=glibc glibc

$(EXEC): clean $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

$(CHECKERSLIB)-glibc.a:
	$(MAKE) -C $(checkersdir) BUILD=glibc glibc

$(MULTIPATHLIB)-glibc.a:
	$(MAKE) -C $(multipathdir) DAEMON=1 BUILD=glibc glibc

install:
	install -d $(DESTDIR)$(bindir)
	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)
	install -d $(DESTDIR)$(rcdir)
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXEC)
	rm -f $(DESTDIR)$(rcdir)/$(EXEC)
	rm -f $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:
	$(MAKE) -C $(multipathdir) prepare DAEMON=1
	rm -f core *.o $(EXEC) *.gz

=== path_priority/pp_alua/Makefile ===
#==============================================================================
# (C) Copyright IBM Corp. 2004, 2005   All Rights Reserved.
#
# Makefile
#
# Tool to make use of a SCSI-feature called Asymmetric Logical Unit Access.
# It determines the ALUA state of a device and prints a priority value to
# stdout.
#
# Author(s): Jan Kunigk
#            S. Bader <shbader@de.ibm.com>
#
# This file is released under the GPL.
#==============================================================================
EXEC		= mpath_prio_alua
BUILD		= glibc
DEBUG		= 0
DEBUG_DUMPHEX	= 0
OBJS		= main.o rtpg.o
INSTALL		= install -D

TOPDIR	= ../..

ifneq ($(shell ls $(TOPDIR)/Makefile.inc 2>/dev/null),)
include $(TOPDIR)/Makefile.inc
endif

CFLAGS += -DDEBUG=$(DEBUG)

all: $(BUILD)

glibc:	$(OBJS)
	$(CC) -o $(EXEC) $(OBJS) $(LDFLAGS)

klibc:	$(OBJS)
	$(CC) -static -o $(EXEC) $(OBJS)

install: $(BUILD) $(EXEC).8.gz
	$(INSTALL) -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)
	$(INSTALL) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)/$(EXEC).8.gz

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:	
	rm -f *.o *.gz $(EXEC)

$(EXEC).8.gz:	$(EXEC).8
	$(GZIP) $< >$@

main.o:	main.c rtpg.h spc3.h

rtpg.o:	rtpg.c rtpg.h spc3.h

=== path_priority/pp_balance_units/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD = glibc
DEBUG = 0

TOPDIR	= ../..
include $(TOPDIR)/Makefile.inc

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS += -I/usr/include -DDEBUG=$(DEBUG)
	OBJS = pp_balance_units.o $(MULTIPATHLIB)-$(BUILD).a
else
	CFLAGS += -I$(multipathdir) -DDEBUG=$(DEBUG)
	LDFLAGS = -ldevmapper
	OBJS = pp_balance_units.o $(MULTIPATHLIB)-$(BUILD).a
endif

EXEC = mpath_prio_balance_units

all: $(BUILD)

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) -o $(EXEC) $(OBJS) $(LDFLAGS)

klibc: prepare $(OBJS)
	$(CC) -static -o $(EXEC) $(CRT0) $(OBJS) $(KLIBC) $(LIBGCC)

$(MULTIPATHLIB)-$(BUILD).a:
	make -C $(multipathdir) BUILD=$(BUILD) $(BUILD)

install:
	install -d $(DESTDIR)$(bindir)
	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)

clean:
	rm -f core *.o $(EXEC) *.gz

=== path_priority/pp_emc/Makefile ===
EXEC		= mpath_prio_emc
BUILD		= glibc
OBJS		= pp_emc.o

TOPDIR		= ../..
include $(TOPDIR)/Makefile.inc

all: $(BUILD)

glibc:	$(OBJS)
	$(CC) -o $(EXEC) $(OBJS) $(LDFLAGS)

klibc:	$(OBJS)
	$(CC) -static -o $(EXEC) $(OBJS)

install: $(EXEC)
	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
clean:	
	rm -f *.o $(EXEC)

%.o:	%.c
	$(CC) $(CFLAGS) -c -o $@ $<

=== path_priority/pp_netapp/Makefile ===
EXEC		= mpath_prio_netapp
BUILD		= glibc
OBJS		= pp_netapp.o

TOPDIR		= ../..
include $(TOPDIR)/Makefile.inc

all: $(BUILD)

glibc:	$(OBJS)
	$(CC) -o $(EXEC) $(OBJS) $(LDFLAGS)

klibc:	$(OBJS)
	$(CC) -static -o $(EXEC) $(OBJS)

install: $(EXEC)
	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
clean:	
	rm -f *.o $(EXEC)

=== path_priority/pp_random/Makefile ===
EXEC		= mpath_prio_random
BUILD		= glibc
OBJS		= pp_random.o

TOPDIR		= ../..
include $(TOPDIR)/Makefile.inc

all: $(BUILD)

glibc:	$(OBJS)
	$(CC) -o $(EXEC) $(OBJS) $(LDFLAGS)

klibc:	$(OBJS)
	$(CC) -static -o $(EXEC) $(OBJS)

install: $(EXEC)
	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
clean:	
	rm -f *.o $(EXEC)

## multipath-tools 0.4.8

=== Makefile ===
--- 
+++ 
@@ -20,9 +20,13 @@
 export KRNLSRC
 export KRNLOBJ
 
-BUILDDIRS = $(shell find . -mindepth 2 -name Makefile -exec dirname {} \; | grep -v ^lib)
+BUILDDIRS = $(shell find . -mindepth 2 -name Makefile -exec dirname {} \; | grep -vE '^lib|/\.')
 
+ifeq   ($(MULTIPATH_VERSION),)
 VERSION = $(shell basename ${PWD} | cut -d'-' -f3)
+else
+VERSION = $(MULTIPATH_VERSION)
+endif
 
 all: recurse

=== devmap_name/Makefile ===
--- 
+++ 
@@ -28,9 +28,9 @@
 	$(CC) -static -o $(EXEC) $(OBJS)
 	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
 
-install:
+install: $(EXEC) $(EXEC).8
 	install -d $(DESTDIR)$(bindir)
-	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/
+	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/
 	install -d $(DESTDIR)$(mandir)
 	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

=== kpartx/Makefile ===
--- 
+++ 
@@ -6,15 +6,15 @@
 
 include ../Makefile.inc
 
-CFLAGS += -I. -D_LARGEFILE64_SOURCE
+CFLAGS += -I. -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 
 ifeq ($(strip $(BUILD)),klibc)
 	OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o gpt.o crc32.o \
-	       lopart.o xstrncpy.o devmapper.o dasd.o mac.o \
+	       lopart.o xstrncpy.o devmapper.o dasd.o mac.o sun.o \
 	       $(MULTIPATHLIB)-$(BUILD).a $(libdm)
 else
 	LDFLAGS = -ldevmapper
-	OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o dasd.o \
+	OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o dasd.o sun.o \
 	       gpt.o mac.o crc32.o lopart.o xstrncpy.o devmapper.o
 endif
 
@@ -36,9 +36,13 @@
 $(MULTIPATHLIB)-$(BUILD).a:
 	make -C $(multipathdir) BUILD=$(BUILD)
 
-install:
+install: $(EXEC) $(EXEC).8
 	install -d $(DESTDIR)$(bindir)
-	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)
+	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
+	install -d $(DESTDIR)$(libudevdir)
+	install -m 755 kpartx_id $(DESTDIR)$(libudevdir)
+	install -d $(DESTDIR)/etc/udev/rules.d
+	install -m 644 kpartx.rules $(DESTDIR)/etc/udev/rules.d/
 	install -d $(DESTDIR)$(mandir)
 	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

=== libcheckers/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 include ../Makefile.inc
 
-OBJS = checkers.o readsector0.o tur.o directio.o emc_clariion.o hp_sw.o
+OBJS = libsg.o checkers.o readsector0.o tur.o directio.o emc_clariion.o hp_sw.o rdac.o
 
 all: $(BUILD)

=== libmultipath/Makefile ===
--- 
+++ 
@@ -6,22 +6,29 @@
 
 include ../Makefile.inc
 
-CFLAGS = -I$(checkersdir)
+CFLAGS += -I$(checkersdir)
 
 OBJS = memory.o parser.o vector.o devmapper.o callout.o \
        hwtable.o blacklist.o util.o dmparser.o config.o \
        structs.o discovery.o propsel.o dict.o \
        pgpolicies.o debug.o regex.o defaults.o uevent.o \
        switchgroup.o uxsock.o print.o alias.o log_pthread.o \
-       log.o configure.o structs_vec.o
+       log.o configure.o structs_vec.o sysfs.o
 
 PREVBUILD = $(shell nm debug.o 2> /dev/null|grep log_safe)
 
 ifeq ($(strip $(DAEMON)),1)
+	OBJS += lock.o waiter.o
 	CFLAGS += -DDAEMON
 	CLEAN = $(shell if [ "x$(PREVBUILD)" = "x" ]; then echo clean; fi)
 else
 	CLEAN = $(shell if [ ! "x$(PREVBUILD)" = "x" ]; then echo clean; fi)
+endif
+
+LIBDM_API_FLUSH = $(shell objdump -T /lib/libdevmapper.so.* | grep -c dm_task_no_flush)
+
+ifeq ($(strip $(LIBDM_API_FLUSH)),1)
+	CFLAGS += -DLIBDM_API_FLUSH
 endif
 
 all: $(BUILD)

=== multipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
BUILD = glibc

include ../Makefile.inc

OBJS = main.o $(MULTIPATHLIB)-$(BUILD).a $(CHECKERSLIB)-$(BUILD).a

CFLAGS += -I$(multipathdir) -I$(checkersdir)
LDFLAGS += -laio

ifeq ($(strip $(BUILD)),klibc)
	OBJS += $(libdm)
else
	LDFLAGS += -ldevmapper
endif

EXEC = multipath

all: $(BUILD)

prepare:
	make -C $(multipathdir) prepare
	rm -f core *.o *.gz
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	$(GZIP) $(EXEC).conf.5 > $(EXEC).conf.5.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)

klibc: prepare $(OBJS)
	$(CC) -static -o $(EXEC) $(CRT0) $(OBJS) $(KLIBC) $(LIBGCC)

$(CHECKERSLIB)-$(BUILD).a:
	make -C $(checkersdir) BUILD=$(BUILD) $(BUILD)

$(MULTIPATHLIB)-$(BUILD).a:
	make -C $(multipathdir) BUILD=$(BUILD) $(BUILD)

install:
	install -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	install -d $(DESTDIR)/etc/udev/rules.d
	install -m 644 multipath.rules $(DESTDIR)/etc/udev/rules.d/
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)
	install -d $(DESTDIR)$(man5dir)
	install -m 644 $(EXEC).conf.5.gz $(DESTDIR)$(man5dir)

uninstall:
	rm $(DESTDIR)/etc/udev/rules.d/multipath.rules
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz
	rm $(DESTDIR)$(man5dir)/$(EXEC).conf.5.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== multipathd/Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # basic flags setting
 #
 CFLAGS += -DDAEMON -I$(multipathdir) -I$(checkersdir)
-LDFLAGS = -lpthread -ldevmapper -lsysfs -lreadline -lncurses
+LDFLAGS = -lpthread -ldevmapper -lreadline -lncurses -laio
 
 #
 # debuging stuff
@@ -45,7 +45,7 @@
 
 install:
 	install -d $(DESTDIR)$(bindir)
-	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)
+	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
 	install -d $(DESTDIR)$(rcdir)
 	install -d $(DESTDIR)$(mandir)
 	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

=== path_priority/pp_alua/Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 klibc:	$(OBJS)
 	$(CC) -static -o $(EXEC) $(OBJS)
 
-install: $(BUILD) $(EXEC).8.gz
+install: $(EXEC) $(EXEC).8.gz
 	$(INSTALL) -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)
 	$(INSTALL) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)/$(EXEC).8.gz

=== path_priority/pp_balance_units/Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 
 install:
 	install -d $(DESTDIR)$(bindir)
-	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/
+	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
 
 uninstall:
 	rm $(DESTDIR)$(bindir)/$(EXEC)

=== path_priority/pp_emc/Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	$(CC) -static -o $(EXEC) $(OBJS)
 
 install: $(EXEC)
-	install -s -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)
+	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)
 
 uninstall:
 	rm $(DESTDIR)$(bindir)/$(EXEC)

=== path_priority/pp_hds_modular/Makefile ===
EXEC		= mpath_prio_hds_modular
BUILD		= glibc
OBJS		= pp_hds_modular.o

TOPDIR		= ../..
include $(TOPDIR)/Makefile.inc

all: $(BUILD)

glibc:	$(OBJS)
	$(CC) -o $(EXEC) $(OBJS) $(LDFLAGS)

klibc:	$(OBJS)
	$(CC) -static -o $(EXEC) $(OBJS)

install: $(EXEC)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
clean:	
	rm -f *.o $(EXEC)

=== path_priority/pp_hp_sw/Makefile ===
EXEC		= mpath_prio_hp_sw
BUILD		= glibc
OBJS		= pp_hp_sw.o

TOPDIR		= ../..
include $(TOPDIR)/Makefile.inc

all: $(BUILD)

glibc:	$(OBJS)
	$(CC) -o $(EXEC) $(OBJS) $(LDFLAGS)

klibc:	$(OBJS)
	$(CC) -static -o $(EXEC) $(OBJS)

install: $(EXEC)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
clean:	
	rm -f *.o $(EXEC)

%.o:	%.c
	$(CC) $(CFLAGS) -c -o $@ $<

## multipath-tools 0.4.8+git0.761c66f-10

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,7 @@
 # Makefile
 #
 # Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
-
-BUILD = glibc
+#
 
 #
 # Try to supply the linux kernel headers.
@@ -20,7 +19,13 @@
 export KRNLSRC
 export KRNLOBJ
 
-BUILDDIRS = $(shell find . -mindepth 2 -name Makefile -exec dirname {} \; | grep -vE '^lib|/\.')
+BUILDDIRS = \
+	libmultipath \
+	libmultipath/prioritizers \
+	libmultipath/checkers \
+	multipath \
+	multipathd \
+	kpartx
 
 ifeq   ($(MULTIPATH_VERSION),)
 VERSION = $(shell basename ${PWD} | cut -d'-' -f3)

=== kpartx/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
include ../Makefile.inc

CFLAGS += -I. -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

LDFLAGS = -ldevmapper
OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o dasd.o sun.o \
       gpt.o mac.o crc32.o lopart.o xstrncpy.o devmapper.o
EXEC = kpartx

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	
install: $(EXEC) $(EXEC).8
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) -m 755 kpartx_id $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)/etc/udev/rules.d
	$(INSTALL_PROGRAM) -m 644 kpartx.rules $(DESTDIR)/etc/udev/rules.d/
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXEC)
	rm -f $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== libmultipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
include ../Makefile.inc

LIBS = libmultipath.so

OBJS = memory.o parser.o vector.o devmapper.o callout.o \
       hwtable.o blacklist.o util.o dmparser.o config.o \
       structs.o discovery.o propsel.o dict.o \
       pgpolicies.o debug.o regex.o defaults.o uevent.o \
       switchgroup.o uxsock.o print.o alias.o log_pthread.o \
       log.o configure.o structs_vec.o sysfs.o prio.o checkers.o \
       lock.o waiter.o

LIBDM_API_FLUSH = $(shell if test -d /lib64 ; then objdump -T /lib64/libdevmapper.so* ; else objdump -T /lib/libdevmapper.so.* ; fi | grep -c dm_task_no_flush)

ifneq ($(strip $(LIBDM_API_FLUSH)),0)
	CFLAGS += -DLIBDM_API_FLUSH -D_GNU_SOURCE
endif

all: $(LIBS)

$(LIBS): $(OBJS)
	$(CC) $(SHARED_FLAGS) -Wl,-soname,$@ $(CFLAGS) -o $@ $(OBJS)

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(libdir)

uninstall:
	rm -f $(DESTDIR)$(syslibdir)/$(LIBS)

clean:
	rm -f core *.a *.o *.gz *.so

=== multipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
include ../Makefile.inc

OBJS = main.o

CFLAGS += -I$(multipathdir)
LDFLAGS += -lpthread -ldevmapper -ldl -lmultipath -L$(multipathdir)

EXEC = multipath

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	$(GZIP) $(EXEC).conf.5 > $(EXEC).conf.5.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(INSTALL_PROGRAM) -d $(DESTDIR)/etc/udev/rules.d
	$(INSTALL_PROGRAM) -m 644 multipath.rules $(DESTDIR)/etc/udev/rules.d/
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man5dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).conf.5.gz $(DESTDIR)$(man5dir)

uninstall:
	rm $(DESTDIR)/etc/udev/rules.d/multipath.rules
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz
	rm $(DESTDIR)$(man5dir)/$(EXEC).conf.5.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== libmultipath/checkers/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
include ../../Makefile.inc

LIBS= \
	libcheckcciss_tur.so \
	libcheckreadsector0.so \
	libchecktur.so \
	libcheckdirectio.so \
	libcheckemc_clariion.so \
	libcheckhp_sw.so \
	libcheckrdac.so

CFLAGS += -I..

all: $(LIBS)

libcheckdirectio.so: libsg.o directio.o
	$(CC) $(SHARED_FLAGS) -o $@ $^ -laio

libcheck%.so: libsg.o %.o
	$(CC) $(SHARED_FLAGS) -o $@ $^

install:
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do rm -f $(DESTDIR)$(libdir)/$$file; done

clean:
	rm -f core *.a *.o *.gz *.so

=== libmultipath/prioritizers/Makefile ===
# Makefile
#
# Copyright (C) 2007 Christophe Varoqui, <christophe.varoqui@free.fr>
#
include ../../Makefile.inc

LIBS = \
	libpriorandom.so \
	libprioconst.so \
	libpriohp_sw.so \
	libprioemc.so \
	libpriordac.so \
	libprioalua.so \
	libprionetapp.so \
	libpriohds.so

CFLAGS += -I..

all: $(LIBS)

libprioalua.so: alua.o alua_rtpg.o
	$(CC) $(SHARED_FLAGS) -o $@ $^

libprio%.so: %.o
	$(CC) $(SHARED_FLAGS) -o $@ $^

install: $(LIBS)
	$(INSTALL_PROGRAM) -m 755 libprio*.so $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do rm -f $(DESTDIR)$(libdir)/$$file; done

clean:
	rm -f core *.a *.o *.gz *.so

=== debian/changelog ===
multipath-tools (0.4.8+git0.761c66f-10) stable-proposed-updates; urgency=low

  * [b5f7694] Change HP hardware hanlder to hp_sw.
    Thanks to Phil (Closes: 587315)
  * [4aae2ad] Update man pages (Closes: 644913)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 30 Oct 2011 23:54:39 +0530

multipath-tools (0.4.8+git0.761c66f-9) unstable; urgency=low

  * [0435cc1] Make sure the patchcheckers end up in /lib (Closes: #581377)
  * [858f733] New patch 0011-multipath-fix-offset-for-containted- slices.patch
    multipath: fix offset for containted slices. (Closes: #586104) - thanks to
    Benjamin Marzinski

 -- Guido Günther <agx@sigxcpu.org>  Wed, 16 Jun 2010 20:02:47 +0200

multipath-tools (0.4.8+git0.761c66f-8) unstable; urgency=low

  * [16268d8] Drop path from dmsetup_env call - thanks to Ferenc Wagner
  * [2f3bdd5] Use $name in multipath.udev as well - thanks to Ferenc Wagner
    for testing
  * [c978487] Don't pass -g on mips(el) to work around a binutils bug.  See
    http://sources.redhat.com/bugzilla/show_bug.cgi?id=10144 for details.
  * [9daf438] Make sure we discover multipaths before checkfs/mountall runs
    This covers the cornercase where e.g. /home is on multipath (but not on
    LVM) and multipath-tols aren't started via initramfs. (Closes: #577172)
  * [f7cc840] Bump standards version

 -- Guido Günther <agx@sigxcpu.org>  Sun, 11 Apr 2010 13:22:35 +0200

multipath-tools (0.4.8+git0.761c66f-7) unstable; urgency=low

  * [13f7436] Properly add multipath-udeb to dh_makeshlibs (Closes: #564489) -
    thanks to again Frans Pop

 -- Guido Günther <agx@sigxcpu.org>  Sat, 23 Jan 2010 00:14:04 +0100

multipath-tools (0.4.8+git0.761c66f-6) unstable; urgency=low

  * [5b0c7be] Fix dependency on nonexistent multipath-tools udeb (Closes:
    #564489) - thanks to Frans Pop
  * [c2a06f7] New patch debian/patches/0010-Dots-are-special-in- groff.patch
    Dots are special in groff

 -- Guido Günther <agx@sigxcpu.org>  Sun, 10 Jan 2010 18:10:05 +0100

multipath-tools (0.4.8+git0.761c66f-5) unstable; urgency=low

  * [9c68527] Explicitly include posix_types.h to get the correct type for
    __kernel_old_dev_t (Closes: #558990)

 -- Guido Günther <agx@sigxcpu.org>  Sat, 05 Dec 2009 18:14:05 +0100

multipath-tools (0.4.8+git0.761c66f-4) unstable; urgency=low

  * [eb7bcf2] Add kpartx_id to initramfs for persistent partition links.
  * [7ecd444] Use $name instead of $kernel since 2.6.31 doesn't create
    /dev/dm-* anymore.

 -- Guido Günther <agx@sigxcpu.org>  Sat, 21 Nov 2009 21:11:31 +0100

multipath-tools (0.4.8+git0.761c66f-3) unstable; urgency=low

  * upload to unstable
  * [f62b619] Tighten multipath-tools-boot dependency Older versions might not
    be able to cope with renamed patch checkers, etc.
  * [7bb23db] Add udev rules to initramfs This makes the initramfs properly
    event based. Once #455979 is fixed in LVM, root on lvm on multipatph can
    work reliably. (Closes: #539498)
  * [d9fcc80] Another init script dependency fix (Closes: #542370) - thanks to
    Petter Reinholdtsen
  * [3faab35] redo patches
  * [c903696] Make user_friendly_names compatible to multipath-tools 0.4.8 and
    earlier

 -- Guido Günther <agx@sigxcpu.org>  Sat, 21 Nov 2009 18:04:07 +0100

multipath-tools (0.4.8+git0.761c66f-2) experimental; urgency=low

  * [34758f1] don't install files into /lib64 on 64 bit architectures - thanks
    to Pascal de Bruijn
  * [2b0a3da] use libreadline-dev (Closes: #553813)
  * [8394b3a] cherry-pick 362d2e5f215894818b52a0d03b723b75917390fb (Closes:
    #555901)

 -- Guido Günther <agx@sigxcpu.org>  Thu, 12 Nov 2009 17:35:28 +0100

multipath-tools (0.4.8+git0.761c66f-1) experimental; urgency=low

  * upload current git snapshot to experimental
  * [71c9c74] warn about user_friendly_names and suggest using /dev/disk/by-id/
  * [329762e] increase locking timeout on bindings file to 30 secs - thanks to
    Ritesh Raj Sarraf for the patch
  * [759ad9b] add spanish translation (Closes: #528972) - thanks to Fernando
    González de Requena
  * [7c327fa] add Czech translation (Closes: #533524) - thanks to Tomas Fidler
  * [49c78ba] drop patches merged upstream:
        * 0001-get-rid-of-arch-specific-ifdef-spaghettis.patch
        * 0002--libmultipath-filter_wwid-is-called-with-the-wron.patch
        * 0004--kpartx-fix-extended-partition-handling.patch
        * 0005--kpartx-remove-partitions-in-reverse-order.patch
        * 0006--kpartx-documentation-fixes.patch
        * 0007--kpartx-remove-dead-code.patch
        * 0008-udev-as-of-0.124-doesn-t-support-scsi_id-s-anymor.patch
        * 0011--kpartx-use-uint64_t-to-account-slices-start-size.patch
        * 0012--libmultipath-Update-discovery-to-work-with-new-sys.patch
        * 0013-multipathd-crash-on-shutdown.patch
        * 0014--var-run-multipathd.sock-is-world-writable.patch
        * 0015-Increase-timeout-to-30-secs-to-avoid-locking-issue.patch
  * [52b5373] checkers and prio callouts are now SOs
  * [e493cde] debian/rules: use --fail-missing
  * [b1c5baf] devmap_name is no more
  * [fd41e76] bump standards version
  * [82dc3df] drop iscsi to work around #542370
  * [cce7640] new patch:
    0004-check-header-file-for-defintion-of-dm_task_no_flush: check the header
    file for dm_task_no_flush instead
    of one of the installed libs.
  * [876a5fb] new patch: 0005-set-a-soname.patch add a soname to libmultipath
  * [1912767] new patch 0006-add-library-dependencies.patch add libraries to
    the linker call
  * [4d1b506] add dh_makeshlibs call
  * [1ee06d5] install lib with soname

 -- Guido Günther <agx@sigxcpu.org>  Sun, 30 Aug 2009 15:53:24 +0200

multipath-tools (0.4.8-15) unstable; urgency=low

  * [e3fdd6f] add iscsi as a prereq and add verbose logic from mdadm.
  * [9299e3d] On shutdown multipathd flushes its internal message queue
    but we have to check if the messages on the queue are not empty.
    (Closes: #519252)
  * [df5ee21] fix umask of multipathd socket (CVE-2009-0115). Upstream


=== debian/control ===
Source: multipath-tools
Section: admin
Priority: extra
Maintainer: Debian LVM Team <pkg-lvm-maintainers@lists.alioth.debian.org>
Uploaders: Guido Günther <agx@sigxcpu.org>
Build-Depends: debhelper (>= 5.0.45), po-debconf, libdevmapper-dev (>= 2:1.02.20), libreadline-dev, quilt (>= 0.40), libaio-dev
XS-Vcs-Git: git://git.debian.org/git/pkg-lvm/multipath-tools.git
XS-Vcs-Browser: http://git.debian.org/?p=pkg-lvm/multipath-tools.git
Standards-Version: 3.8.4

Package: multipath-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>= 0.124), initscripts (>= 2.85-16),
 kpartx (>= ${binary:Version}), lsb-base (>= 3), libaio1 (>= 0.3.106-8)
Conflicts: multipath-tools-initramfs (<= 1.0.1),
 multipath-tools-boot (<= 0.4.8+git0.761c66f-2~)
Suggests: multipath-tools-boot
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: kpartx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 0.086), dmsetup (>= 2:1.02.24)
Replaces: multipath-tools (<< 0.4.7-3)
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

Package: multipath-tools-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools, 
 multipath-tools (>= ${source:Version}), multipath-tools (<< ${source:Version}.1~)
Replaces: multipath-tools-initramfs (<< 1.0.1+nmu1)
Conflicts: multipath-tools-initramfs (<< 1.0.1+nmu1)
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
XC-Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}, multipath-modules
Section: debian-installer
Description: maintain multipath block device access
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/quilt/quilt.make

INITRAMFS=$(CURDIR)/debian/multipath-tools-boot/usr/share/initramfs-tools/

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
        INSTALL_PROGRAM = install -s
else
        INSTALL_PROGRAM = install
endif

# Work around misp(el) linker bug:
# http://sources.redhat.com/bugzilla/show_bug.cgi?id=10144
DEB_HOST_ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
  OPTFLAGS = "OPTFLAGS=-pipe -Wall -Wunused -Wstrict-prototypes"
endif

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-stamp
build-stamp: patch
	dh_testdir

	$(MAKE) $(OPTFLAGS) LIB=lib

	touch $@

clean-tree:
	$(MAKE) clean

clean: clean-tree unpatch
	dh_testdir
	rm -f build-stamp
	dh_clean
	debconf-updatepo

install:
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	mkdir -p $(CURDIR)/debian/tmp/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=lib
	install -m 755 debian/dmsetup_env $(CURDIR)/debian/tmp/lib/udev/
	dh_install -X.rules --fail-missing --sourcedir=$(CURDIR)/debian/tmp
	# initramfs stuff:
	install -D -m 755 debian/initramfs/hooks $(INITRAMFS)/hooks/multipath
	install -D -m 755 debian/initramfs/local-top \
		$(INITRAMFS)/scripts/local-top/multipath
	# reportbug:
	for pkg in "multipath-tools" "multipath-tools-boot"; do \
	    install -D -m 755 debian/reportbug/script debian/$${pkg}/usr/share/bug/$${pkg}/script; \
	done

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_installinit -pmultipath-tools
	dh_installinit -pmultipath-tools --name=multipath-tools-boot --no-start -- start 21 S .
	dh_installudev -pkpartx
	dh_installudev -pmultipath-tools --name=multipath
	dh_installdebconf -pmultipath-tools-boot
	dh_installman
	dh_makeshlibs --add-udeb=multipath-udeb
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary:	binary-indep binary-arch
.PHONY: binary binary-arch binary-indep unpack configure build clean
